<?php

class MnglBoardsHelper
{
  function display_message($message_class, $message)
  {
    $hidden = '';

    if(strlen($message) >= 255)
    {
      $hidden = ' class="mngl-hidden"';
      $teaser = mb_substr($message,0,255) . "...";
      $class_suffix = '-fake';
      
      $teaser_class = $message_class . $class_suffix;
      
      ?><span id="<?php echo $teaser_class; ?>"><?php echo MnglBoardsHelper::format_message($teaser) ?> <a href="javascript:mngl_toggle_two_ids('#<?php echo $message_class; ?>','#<?php echo $teaser_class; ?>')"><?php _e('Read More', 'mingle'); ?></a></span><?php
    }
    ?><span id="<?php echo $message_class; ?>"<?php echo $hidden; ?>><?php echo MnglBoardsHelper::format_message($message); ?></span><?php
  }
  
  function format_message($message)
  {
    $message = stripslashes($message);
    $message = strip_tags($message);
    $message = preg_replace("#\n#","<br/>",$message);
    $message = preg_replace('#(\bhttps?://[a-zA-Z0-9.\-]+\.[a-zA-Z0-9/?=.\-_%&+\#]+)#', "<a href=\"$1\">$1</a>", $message);
    $message = preg_replace('/ -- /', ' &ndash; ', $message);
    $message = preg_replace('/--/', '&mdash;', $message);
    
    return $message;
  }

  function board_post_url($board_post_id)
  {
    global $mngl_options;

    if(isset($mngl_options->profile_page_id) and $mngl_options->profile_page_id != 0)
    {
      $permalink = get_permalink($mngl_options->profile_page_id);
      $param_char = ((preg_match("#\?#",$permalink))?'&':'?');
      return "{$permalink}{$param_char}mbpost={$board_post_id}";
    }

    return '';
  }
}
?>
